
$('#signIn').on("click", function(event) {
	event.preventDefault();
	var $clientOrgSelect = $("#clientOrgSelect");
	$('#error-msg').hide();
	
	var clientOrgJSON = function(repsonseString) {
		return repsonseString.indexOf('JSON') === 0;			  
	};
	
	
	// Process client org data 
	var processClientOrg = function(repsonseString) {
		$("#client-org").show();
		$("#user-password").hide();
		$("#username-input").hide();
		  var json = JSON.parse(repsonseString.substring(5, repsonseString.length));			  
		  $clientOrgSelect.html('');
		  $.each(json, function(i, clientOrg) {
			  $clientOrgSelect.append($('<option/>', { 
			        value: clientOrg.orgRef,
			        text : clientOrg.orgName 
			    }));
			});	
	};
	
	// Check for error
	var checkError = function(repsonseString) {
		return repsonseString.indexOf('ERRORJSON') === 0	
	};
	// Process the error
	var processError = function(responseString) {
		var string = responseString.substring(10, responseString.length);
		var json = JSON.parse(string);			  
		$('#error-msg').show();
		$('#error-msg').html(json.message);
	};
	
	// assign the client org
	var clientOrg = null;
	if ($("#client-org").is(":visible")) {
		clientOrg = $clientOrgSelect.val();
	}
	
	var error = false;
	if ($("#user-password").val() == null || String($("#user-password").val()).trim() == "") {
		 $('#error-msg').show();
		 $('#error-msg').html("Username and password can not be blank");
		 error = true;
	}
	if ($("#username-input").val() == null || String($("#username-input").val()).trim() == "") {
		 $('#error-msg').show();
		 $('#error-msg').html("Username and password can not be blank");
		 error = true;
	}
	
	// This method calls an iFrame which is then processed by the UIWebView in the iOS app
	var callJavaScriptBridge = function(token) {
		var iframe = document.createElement("IFRAME");
	    iframe.setAttribute("src", "yfj2o://yftoken=" + token);
	    iframe.setAttribute("height", "1px");
	    iframe.setAttribute("width", "1px");
	    document.documentElement.appendChild(iframe);
	    iframe.parentNode.removeChild(iframe);
	    iframe = null;
	};
				
	if (!error) {
		$.ajax({
			type: "POST",
			url: "mobileSSO.jsp",
			data: {
				userId : $("#username-input").val(),
				password : $("#user-password").val(),
				clientOrg : clientOrg
			},
			success: function(data){
				var repsonseString = String(data).trim();
				if (clientOrgJSON(repsonseString))
					processClientOrg(repsonseString);
				else if (checkError(repsonseString)) {
					processError(repsonseString);
				} else {
					callJavaScriptBridge(String(data).trim());	
				}
			},
			error: function(XMLHttpRequest, textStatus, errorThrown) {
				$('#error-msg').show();
				$('#error-msg').html("SSO Error, please speak to your system administrator");			 
			}
		});				
	}
});

