<%@ page language="java" contentType="text/html; charset=UTF-8" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html" %>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean" %>
<%@ taglib uri="http://www.yellowfin.com.au/tags/yellowfin-app" prefix="app" %>
<%@ page import="com.hof.data.*" %>
<%@ page import="com.hof.util.*, java.util.*, java.text.*" %>
<%@ page import="com.hof.web.form.*" %>
<%@ page import="com.hof.mi.web.service.*" %>
<%@ page import="org.json.*" %>
<%

/*
* This is an example of using a custom mobile signin page with user feedback using the mobile SSO option 
* To enable this option insert the below row into the Yellowfin config table pointing to your own SSO jsp
* INSERT INTO Configuration (IpOrg, ConfigTypeCode, ConfigCode, ConfigData) values (1, 'SYSTEM', 'MOBILE_SSO_LOCATION', 'http://10.10.0.10:8080/yellowfin71/mobileSSO/mobileSSO.jsp')
* 
* Once the user is signed in you must call the below URL with web service token appened
* yfj2o://yftoken=webservicetokenhere
* This will pass the token to the mobile app 
*/

/*
 * The iOS app will pass the user id entered in the settings page on the app to this jsp as a paramter which 
 * can be accessed using the mobileUsername parameter of the request
 */
String mobileUsername = request.getParameter("mobileUsername") == null ? "" : request.getParameter("mobileUsername");
/*
 * The userId and password parameters are posted via ajax using the  
 * 
 */
String clientusername = request.getParameter("userId");
String clientpassword = request.getParameter("password");
String clientOrg = request.getParameter("clientOrg");

if (clientusername != null && clientpassword != null) {
	
	/*
	*	Setup the AdministrationServiceClient to connect to the Yellowfin webservice
	*/
	
	String Host = "localhost";
	int Port = 8080;
	String Username = "admin@yellowfin.com.au";
	String Password = "test";
	String Location = "/yellowfin71/services/AdministrationService";
		
	AdministrationServiceClient asc = null;
	asc = new AdministrationServiceClient(Host, Port, Username, Password, Location);
	String output = null;
	
	// Signin the user with the passed in parameters
	
	AdministrationPerson ap = new AdministrationPerson();
	ap.setUserId(clientusername);
	ap.setPassword(clientpassword);
	   
	 // Validate that the user exists in Yellowfin
	boolean result = asc.validateUserAllOrgs(clientusername, clientpassword);
	  
	  if (result) {
	  // The logic for user feedback and posting of data is handled by mobileSSO.js
	    AdministrationClientOrg[] clients = asc.getUserAccess(ap);
			if (clientOrg != null)
				if ("".equals(clientOrg.trim()))
					clientOrg = null;
			if (clients.length > 0 && clientOrg == null) {
				JSONArray orgArray = new JSONArray();
				// Generate a json array of client orgs for the user to select
				for (AdministrationClientOrg client : clients) {
					JSONObject clientOrgJSON = new JSONObject();
					clientOrgJSON.put("orgName", client.getClientName());
					clientOrgJSON.put("orgId", client.getClientId());
					if (client.getClientReferenceId() == null)
						clientOrgJSON.put("orgRef", "DEFAULT ORG");
					else
						clientOrgJSON.put("orgRef", client.getClientReferenceId());

					orgArray.put(clientOrgJSON);
				}
				output = "JSON=" + orgArray.toString();
			} else {
				// set the client org of the user
				if (clientOrg != null && !clientOrg.equals("DEFAULT ORG"))
					asc.setClientReferenceId(clientOrg);
				output = asc.loginUser(ap);
			}

			if (output != null) {
				out.write(output);
			} else {
				// Generate json error message
				JSONObject error = new JSONObject();
				error.put("message", "Error with SSO");
				out.write("ERRORJSON=" + error.toString());
			}
	  } else {
		 // Generate json error message
		  JSONObject error = new JSONObject();
		  error.put("message", "Error with password or username");
		  out.write("ERRORJSON=" + error.toString());
	  }

	} else {
%>
<!DOCTYPE html>
<html>
<head>
   <app:base/>
   <title>Mobile SSO</title>
   <link rel="stylesheet" type="text/css" href="style.css" />  
   <script src="jquery.js"></script>
   <style>
   	#client-org, #error-msg {
   		display: none;
   	}
   	#client-org, #error-msg {
   		display: none;
   	}
   </style>
</head>
<body>
<div class="container">
    <div class="row" style="margin-top:20px;">
		<div  style="margin-left:auto; margin-right:auto; width:400px">
    		<div class="panel panel-default">
			  	<div class="panel-heading">
			    	<h3 class="panel-title">Please sign in</h3>
			 	</div>
					<div class="panel-body">
						<form accept-charset="UTF-8" role="form">
							<fieldset>
								<div class="form-group">
									<input id="username-input" class="form-control" placeholder="E-mail or Login Id"
										name="userId" type="text" value="<%=mobileUsername%>">
										
								</div>
								<div class="form-group">
									<input id="user-password" class="form-control" placeholder="Password"
										name="password" type="password" value="">
								</div>								
								<div id="client-org" class="form-group">
									<select class="form-control" id="clientOrgSelect">										
									</select>
								</div>
								<a href="#" id="signIn" class="btn btn-lg btn-primary btn-block">Sign
									In</a>
							</fieldset>
						</form>
					</div>
				</div>
				<div id="error-msg" class="alert alert-danger" role="alert">
					 <span class="sr-only">Error:</span>
					Enter a valid email address
				</div>
			</div>
	</div>
</div>
<script src="mobileSSO.js"></script>
</body>
</html>
<% } %>